/*
** SellaNMS
** $Id: daemon.cxx,v 1.1 2005/11/06 05:37:27 sella Exp $
** Copyright (c) 2001-2005 Digital Genesis Software, LLC. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

static char rcsid[] = "$Id: daemon.cxx,v 1.1 2005/11/06 05:37:27 sella Exp $";

#include "daemon.h"
#include "tidy.h"
#include <signal.h>

void sighandler(int sig) {
	switch (sig) {
		case SIGUSR1:
			LMSG("Caught SIGUSR1 - daemon");
			break;

		case SIGUSR2:
			LMSG("Caught SIGUSR2 - daemon");
			break;

		default:
			LMSG("Caught unknown signal - daemon");
	}
}

bool start() {
	Tidy *tidy = NULL;

	/* Install Signal Handlers */
	if (signal(SIGUSR1, &sighandler) == SIG_ERR) {
		LMSG("Failed to install signal handler for SIGUSR1.");
	}
	if (signal(SIGUSR2, &sighandler) == SIG_ERR) {
		LMSG("Failed to install signal handler for SIGUSR2.");
	}

	if ((tidy = new Tidy()) != NULL) {
		if (tidy->readConfig() == SUCCESS) {
			tidy->execute();
		}

		SAFE_DELETE(tidy);
	} else {
		LMSG("failed to allocate memory for Tidy().");
	}
}

const char* getName() {
	return "tidyd";
}

const char* getConfigPath() {
	return "internal tidy";
}

const char* getProcTitle() {
	return "tidyd <out>";
}

const char* getDefaultConfigFile() {
	return DEFAULT_CONFIG_FILE;
}

const char* getDefaultPidFile() {
	return DEFAULT_PID_FILE;
}

const char* getDefaultStatFile() {
	return DEFAULT_STAT_FILE;
}

int getDefaultNiceness() {
	return DEFAULT_NICENESS;
}

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim600: fdm=marker
** vim: noet ts=3 sw=3
*/
